# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n = int(fi.readline().strip())
if 2 > n or n > 1000000:
	sys.exit('N out of range')
fo.write('{0}\n'.format(n))

s = 0
for i in range(n):
	k = int(fi.readline().strip())
	if 0 > k or k > 10000:
		sys.exit('K[{0}] out of range'.format(1 + i))
	s += k
	fo.write('{0}\n'.format(k))

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if n <= 1000:
		print('subtask 1')
	else:
		print('subtask 2')
	if s < 2**31:
		print('32-bit signed')
	elif s < 2**32:
		print('32-bit unsigned')
	else:
		print('64-bit')
