#include "testlib.h"
#include <iostream>
#include <stdlib.h>
#include <assert.h>

using namespace std;

typedef long long ll;

int main (int argc, char **argv) {
  registerGen(argc, argv, 1);

  ll seatc = atoll(argv[1]);
  int partyc = atoi(argv[2]);
  assert(partyc <= seatc);

  vector<ll> ans (partyc, 1);
  vector<ll> breaks;
  for (int i = 0; i < partyc - 1; i++) {
    breaks.push_back(rnd.next(0LL, seatc - partyc));
  }
  breaks.push_back(seatc - partyc);
  
  sort(breaks.begin(), breaks.end());

  ans[0] += breaks[0];
  for (int i = 1; i < partyc; i++) {
    ans[i] += breaks[i] - breaks[i - 1];
  }

  cout << seatc << " " << partyc << endl;
  for (int i = 0; i < partyc; i++) {
    cout << ans[i];
    if (i != partyc - 1) {
      cout << " ";
    }
  }
  cout << endl;
}
