#include <iostream>
#include <vector>

using namespace std; // Ärge tehke seda väljaspool võistlusi!

typedef long long ll; // Ega seda!

const int MAX_K = 20;

ll seatc;
ll parties [MAX_K]; // Seda ka mitte!
bool isCoalition (vector<ll> group) {
  // Kontrollib, kas antud parteide rühm saab moodustada koalitsiooni
  ll support = 0;
  for (ll x : group) {
    support += x;
  }

  if (2 * support <= seatc) {
    return false;
  }

  for (ll x : group) {
    if (2 * (support - x) > seatc) {
      return false;
    }
  }

  return true;
}

int partyc;
ll dfs (vector<ll> curGroup, int i) {
  if (i == partyc) {
    return isCoalition(curGroup);
  } else {
    ll ans = dfs(curGroup, i + 1);
    curGroup.push_back(parties[i]);
    ans += dfs(curGroup, i + 1);
    return ans;
  }
}

int main () {
  freopen("koalsis.txt", "r", stdin);
  freopen("koalval.txt", "w", stdout);
  cin >> seatc >> partyc;

  for (int i = 0; i < partyc; i++) {
    cin >> parties[i];
  }

  cout << dfs(vector<ll> (0), 0) << endl;
}
