#include <iostream>
#include <algorithm>

using namespace std;

typedef long long ll;

const int MAX_N = 1000000 + 5;
const int MAX_K = 40 + 5;

ll dp [MAX_K][MAX_N];
// dp[i][j] -- mitu võimalust on valida parteide 1...i seast parteisid nii,
// et nende saadikute arv parlamendis on täpselt j
int parties [MAX_K];

int main () {
  freopen("koalsis.txt", "r", stdin);
  freopen("koalval.txt", "w", stdout);

  int seatc, partyc;
  cin >> seatc >> partyc;

  for (int i = 1; i <= partyc; i++) {
    cin >> parties[i];
  }

  sort(parties + 1, parties + partyc + 1, greater<int> ());
  ll ans = 0;
  dp[0][0] = 1;
  for (int i = 1; i <= partyc; i++) {
    for (int j = 0; j < MAX_N; j++) {
      dp[i][j] += dp[i - 1][j];
      if (j >= parties[i]) {
        dp[i][j] += dp[i - 1][j - parties[i]];
        if (2 * j > seatc && 2 * (j - parties[i]) <= seatc) {
          ans += dp[i - 1][j - parties[i]];
        }
      }
    }
  }
  cout << ans << endl;
}
