import java.util.*;
import java.io.*;

public class sol_full_java {
    public static final int MAX_K = 45;
    public static final int HALF = 18;
    public static final long MAX_N = 1L << 60;

    public static int last_leq (long x, List<Long> arr) {
        if (arr.get(0) > x) {
            return -1;
        }

        int ans = 0;
        for (int k = 1 << HALF; k != 0; k /= 2) {
            if (ans + k < arr.size() && arr.get(ans + k) <= x) {
                ans += k;
            }
        }
        return ans;
    }
    
    public static void main (String[] args) throws Exception {
        Scanner in = new Scanner(new File("koalsis.txt"));
        long seatc = in.nextLong();
        int partyc = in.nextInt();

        Long[] parties = new Long[partyc];
        for (int i = 0; i < partyc; i++) {
            parties[i] = in.nextLong();
        }

        Arrays.sort(parties, Collections.reverseOrder());
        
        List<Long> big_subsets = new ArrayList<Long> ();
        long ans = 0;
        for (int i = 1; i < 1 << Math.min(HALF, partyc); i++) {
            long smallest_size = MAX_N;
            long sum_size = 0;
            for (int j = 0; j < Math.min(HALF, partyc); j++) {
                if ((i & 1 << j) != 0) {
                    sum_size += parties[j];
                    smallest_size = Math.min(smallest_size, parties[j]);
                }
            }

            if ((sum_size - smallest_size < seatc / 2 + 1) && (sum_size >= seatc / 2 + 1)) {
                ans++;
            }
            big_subsets.add(sum_size);
        }

        Collections.sort(big_subsets);

        if (HALF < partyc) {
            for (int i = 1; i < 1 << (partyc - HALF); i++) {
                long smallest_size = MAX_N;
                long sum_size = 0;
                for (int j = 0; j < (partyc - HALF); j++) {
                    if ((i & 1 << j) != 0) {
                        sum_size += parties[j + HALF];
                        smallest_size = Math.min(smallest_size, parties[j + HALF]);
                    }
                }

                if ((sum_size - smallest_size < seatc / 2 + 1) && (sum_size >= seatc / 2 + 1)) {
                    ans++;
                }

                ans += last_leq(seatc / 2 - sum_size + smallest_size, big_subsets)
                    - last_leq(seatc / 2 + 1 - sum_size - 1, big_subsets);
            }
        }

        FileWriter out = new FileWriter("koalval.txt");
        out.write(((Long) ans).toString());
        out.close();
    }
}
