from itertools import product
from collections import deque
data = [ln.strip() for ln in open("ratsusis.txt").readlines()[1:]]
start = ''.join(data).index('@')
q, prev = deque([(start // len(data[0]), start % len(data[0]), 0)]), {}
moves = lambda pos: ((pos[0]+dr*cr, pos[1]+dc*cc, pos[2]+ds) for (dr, dc, ds), cr, cc in product([(1,2,0),(2,1,0),(3,1,1),(1,3,1)],[-1,1],[-1,1])) 
def run():
    while q:
        r, c, s = q.popleft()
        for nr, nc, ns in moves((r,c,s)):
            if 0 <= nr < len(data) and 0 <= nc < len(data[0]) and ns <= 1 and data[nr][nc] != '#' and (nr,nc,ns) not in prev:
                prev[(nr,nc,ns)], _ = (r,c,s), q.append((nr, nc, ns))
                if data[nr][nc] == '*': return nr, nc, ns
def mktrip(r, c, s):
    yield "%d %d" % (r+1, c+1)
    while data[r][c] != '@':
        r, c, s = prev[(r,c,s)]
        yield "%d %d" % (r+1, c+1)
trip = list(reversed(list(mktrip(*run()))))
print("\n".join([str(len(trip)-1)] + trip), file=open('ratsuval.txt', 'w'))