# sisendi korrektsuse kontrollija

import sys
import math

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

def maxm(n) :
	if n <= 2:
		return n
	elif n >= 27:
		return 1e18
	elif n % 2 == 0:
		return 2 * math.factorial((n - 2) // 2) * math.factorial((n - 2) // 2)
	else:
		return 4 * math.factorial((n - 3) // 2) * math.factorial((n - 1) // 2)

(n, m) = [int(_) for _ in fi.readline().strip().split()]
if 2 > n or n > 1e5:
	sys.exit('N out of range')
if 1 > m or m > maxm(n):
	sys.exit('M out of range')
fo.write('{0} {1}\n'.format(n, m))

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if n <= 10:
		print('subtask 1')
	elif n <= 25:
		print('subtask 2')
	elif n <= 1000:
		print('subtask 3')
	else:
		print('subtask 4')
