import os
os.system('g++ -o _correct correct_solution.cpp -O3')
with open('sample_correct_answer.txt') as f:
    tests = f.readlines()
for i in range(len(tests)):
    zi = str(i).zfill(2)
    filename = 'wrong_solutions/{}.cpp'.format(zi)
    os.system('g++ -o _wrong {} -O3'.format(filename))
    with open('_input.txt','w') as f:
        print(tests[i],end='',file=f)
    os.system('./_correct < _input.txt > _answer.txt')
    os.system('./_wrong < _input.txt > _output.txt')
    with open('_output.txt','r') as output_file:
        with open('_answer.txt','r') as answer_file:
            output = output_file.readline().strip()
            answer = answer_file.readline().strip()
            assert(output != answer)
            print('output:\t{}\nanswer:\t{}\n'.format(output,answer))
print('OK: if this ran successfully, all wrong solutions failed')

os.system('rm _answer.txt')
os.system('rm _output.txt')
os.system('rm _input.txt')
os.system('rm _correct')
os.system('rm _wrong')

