# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

(n, k) = [int(_) for _ in fi.readline().strip().split()]
if 1 > n or n > 1e18:
	sys.exit('N out of range')
if 1 > k or k > 36:
	sys.exit('K out of range')
fo.write('{0} {1}\n'.format(n, k))

m = [int(_) for _ in fi.readline().strip().split()]
if len(m) != k:
	sys.exit('Invalid len(M)')
for i in range(len(m)):
	if 1 > m[i] or m[i] > n:
		sys.exit('M[{0}] out of range'.format(1 + i))
if (sum(m) != n):
	sys.exit('Invalid sum(M)')
fo.write('{0}\n'.format(' '.join([str(_) for _ in m])))

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if k == 3:
		print('subtask 1')
	elif k == n:
		print('subtask 2')
	elif k <= 20:
		print('subtask 3')
	elif n <= 1e6:
		print('subtask 4')
	else:
		print('subtask 5')
