# C++ täislahenduse Pythoni port
# Kommentaare loe .cpp failist

HALF = 18
MAX_N = int(1e18 + 5)

def last_leq (x, arr):
    if arr[0] > x:
        return -1

    ans = 0
    k = 1 << HALF
    while k != 0:
        if ans + k < len(arr) and arr[ans + k] <= x:
            ans += k
        k //= 2

    return ans

fin = open("koalsis.txt", "r")
line = fin.readline().split(" ")
seatc = int(line[0])
partyc = int(line[1])

parties = list(map(int, fin.readline().split(" ")))
fin.close()

parties.sort(reverse=True)

ans = 0
big_subsets = [0 for i in range((1 << min(HALF, partyc)) - 1)]
for i in range(1, 1 << min(HALF, partyc)):
    smallest_size = MAX_N
    sum_size = 0
    for j in range(0, min(HALF, partyc)):
        if i & 1 << j:
            sum_size += parties[j]
            smallest_size = min(smallest_size, parties[j])

    if sum_size - smallest_size < seatc // 2 + 1 and sum_size >= seatc // 2 + 1:
        ans += 1
    big_subsets[i - 1] = sum_size

big_subsets.sort()

if HALF < partyc:
    for i in range(1, 1 << (partyc - HALF)):
        smallest_size = MAX_N
        sum_size = 0
        for j in range(partyc - HALF):
            if i & 1 << j:
                sum_size += parties[j + HALF]
                smallest_size = min(smallest_size, parties[j + HALF])

        if sum_size - smallest_size < seatc // 2 + 1 and sum_size >= seatc // 2 + 1:
            ans += 1

        ans += last_leq(seatc // 2 - sum_size + smallest_size, big_subsets) - last_leq(seatc // 2 + 1 - sum_size - 1, big_subsets)

fout = open("koalval.txt", "w")
fout.write(str(ans) + '\n')
fout.close()
