# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

(r, v) = [int(_) for _ in fi.readline().strip().split()]
if 3 > r or r > 100:
	sys.exit('R out of range')
if 3 > v or v > 100:
	sys.exit('V out of range')
fo.write('{0} {1}\n'.format(r, v))

ns = 0
nd = 0
for i in range(r):
	s = fi.readline().strip()
	if len(s) != v:
		sys.exit('Invalid line length')
	for c in s:
		if c not in ['.', '#', '@', '*']:
			sys.exit('Invalid character')
		if c == '@':
			ns += 1
		if c == '*':
			nd += 1
	fo.write('{0}\n'.format(s))
if ns != 1:
	sys.exit('Invalid number of sources')
if nd != 1:
	sys.exit('Invalid number of destinations')

fi.close()
fo.close()
