#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#define M 100

#define MIN(a,b) ((a)<(b) ? (a) : (b))

int m;


int perm[M];
int sum[M];


int pm[M];
int p1[M];

int bsum = 0;
int countsum = 0;

// jõumeetodil lahendus. geneerime kõik permutatsioonid (õiges järjekorras) ja arvutame jooksvalt välja hüpete summa


void gen(int n, int pos, unsigned int mask) {
	if (pos==n) {
		if (bsum == sum[n-1])  {
			countsum++;


		if (countsum == m)
			for (int i=0;i<n;i++)
				pm[i] = perm[i];
		}


		if ((bsum< sum[n-1])) {
			if (bsum < sum[n-1]) {
				bsum = sum[n-1];
				countsum = 1;
			}
			for (int i=0;i<n;i++)
				p1[i] = perm[i];
			return;
		}
		return;
	}

	for (unsigned int j=0;j<n;j++) {
		if (((1<<j) &  mask)  == 0) {
			perm[pos] = j + 1; 
			sum[pos] = (pos==0) ? 0 : (sum[pos-1] + abs(perm[pos] - perm[pos-1]));
			gen(n,pos+1,mask | (1<<j));
		}
	}
}

int main(int argc, char **argv) {

	int n;

	FILE *infile, *outfile;


	infile = fopen("svejksis.txt","r");
	outfile = fopen("svejkval.txt","w");

	fscanf(infile,"%d %d",&n,&m);


	assert(n<= 8*sizeof(unsigned int));	
	gen(n,0,0);
	fprintf(outfile,"%d %d\n", bsum, countsum);		

	for (int i=0;i<n;i++) 
		fprintf(outfile,"%d ",p1[i]); 

	fprintf(outfile,"\n");

	for (int i=0;i<n;i++) 
		fprintf(outfile,"%d ",pm[i]); 
	fprintf(outfile,"\n");


	fclose(infile);
	fclose(outfile);
	
}
